# Table 2 --------------------------

D=50
p=3;q=2;theta=0.7
Alpha=3;Beta=2;Gamma=7
n=100
w=6
# w=3
# w=2
data1=data.sim(n, Alpha, Beta, Gamma,w)
head(data1)
tail(data1)

t.event=data1$t.event
event1=data1$event1
event2=data1$event2
res.BurrIII=MLE.GFGM.BurrIII(t.event,event1,event2,D,p,q,theta)
res.BurrIII
res.vec=c(as.data.frame(res.BurrIII[4:6])[1,],
                    Iteration=res.BurrIII$Iteration,
                    Randomization=res.BurrIII$Randomization)
res.vec=unlist(res.vec)
res.vec

res.mat=matrix(NA,4,6)
res.mat[,1]=1:4
colnames(res.mat)=c("Init c","aHat","bHat","gHat","Iter","Rand")
for(i in 1:4){
  res.BurrIII=MLE.GFGM.BurrIII(t.event,event1,event2,D,p,q,theta,
                               Gamma.0 = i)
  res.vec=c(as.data.frame(res.BurrIII[4:6])[1,],
                    Iteration=res.BurrIII$Iteration,
                    Randomization=res.BurrIII$Randomization)
  res.vec=unlist(res.vec)
  res.mat[i,-1]=res.vec
}

cat("Alpha =",Alpha,", Beta =", Beta,", Gamma =", Gamma)
res.mat
round(res.mat,4)

# example -------------------------------------------------------

p=3;q=2;theta=0.7;Alpha=2;Beta=2;Gamma=3
Dependence.GFGM(p,q,theta)

XY=GFGM.BurrIII(n=5, p, q, theta, Alpha, Beta, Gamma)
XY

n=200
XY=GFGM.BurrIII(n, p, q, theta, Alpha, Beta, Gamma)
plot(XY)

X=XY[,1]
Y=XY[,2]

w=6
# w=3
# w=2

cen=runif(n,0,w)
XYC=cbind(XY,cen)

t.event = apply(XYC, 1, min)
event1  = as.integer(t.event==X)
event2  = as.integer(t.event==Y)
event3  = 1-event1-event2

Time=apply(XYC, 1, which.min)
Time=as.factor(Time)
levels(Time) = c("Confirmed","Unconfirmed","Censoring")
data1   = data.frame(t.event,Time,event1,event2,event3)

head(data1)
tail(data1)

res.BurrIII=MLE.GFGM.BurrIII(t.event,event1,event2,D=50,p,q,theta)
res.BurrIII
res.mat=as.data.frame(res.BurrIII[4:8])
res.mat
Real=c(Alpha,Beta,Gamma,mBurrIII(Alpha,Gamma),mBurrIII(Beta,Gamma))
Coverage=(res.mat["CI.lower",]<=Real) & (Real<=res.mat["CI.upper",])
res.mat.ext=rbind(res.mat,Real=Real,Coverage=Coverage)
res.mat.ext

Alpha.h = res.BurrIII$Alpha[1]
Beta.h = res.BurrIII$Beta[1]
Gamma.h = res.BurrIII$Gamma[1]

res.spline = MLE.GFGM.spline(t.event,event1,event2,p,q,theta)
g1 = res.spline$g1
g2 = res.spline$g2

CvM.GFGM.BurrIII(t.event,event1,event2,Alpha.h,Beta.h,Gamma.h,g1,g2,p,q,theta,Sdist.plot =F)

# sim mle example --------------------------

p=3;q=2;theta=0.7
Alpha=2;Beta=2;Gamma=3
n=200
w=6
# w=3
# w=2
data1=data.sim(n, Alpha, Beta, Gamma,w)
head(data1)
tail(data1)

sim1=mle.sim(n, Alpha, Beta, Gamma,w)
sim1

# phat=plyr::raply(5,mle.sim(n, Alpha, Beta, Gamma,w),.progress = "text")
phat=replicate(5,mle.sim(n, Alpha, Beta, Gamma,w))
phat
apply(phat, c(1,2), mean)
Real=c(Alpha,Beta,Gamma,mBurrIII(Alpha,Gamma),mBurrIII(Beta,Gamma))
apply(phat[1,,], 1, function(x) mean(x-Real)^2)
apply(phat[1,,], 1, sd)
max(phat[5,1,])

# sim GOF example -----------------------------------------------

p=3;q=2;theta=0.7
Alpha=1.5;Beta=1;Gamma=1

Lambda1=0.5; Lambda2=1

n=200
w=6

B=500


gof.sim.BurrIII(n, Alpha, Beta, Gamma,w)

sim2=replicate(10,gof.sim.BurrIII(n, Alpha, Beta, Gamma,w))
sim2
rowMeans(sim2)
sim3=plyr::raply(10,gof.sim.BurrIII(n, Alpha, Beta, Gamma,w),.progress = "text")
sim3
colMeans(sim3)

boot.gof.sim.BurrIII(n, Alpha, Beta, Gamma,w,B=10)

sim4=plyr::raply(10,boot.gof.sim.BurrIII(n, Alpha, Beta, Gamma,w,B=10),.progress = "text")
sim4=plyr::raply(10,boot.gof.sim.BurrIII(n, Alpha, Beta, Gamma,w,B=10,.progress = "win"),.progress = "text")
sim4
colMeans(sim4)

# Tables 5 6 7 --------------------------------------------------

alpha=rep(c(2,2,3),each=9)
beta=rep(c(2,4,2),each=9)
gamma=rep(c(3,5,7),each=9)

Proportion=rep(c(20,40,60),each=3,times=3)
w.vec=rep(c(6,3,2),each=3,times=3)

N=rep(c(100,200,300),times=9)

param0=cbind(alpha,beta,gamma,Proportion,w=w.vec,n=N)
param0

k=length(alpha)
k

table5=matrix(NA,k,9)
table6=matrix(NA,k,9)
table7=matrix(NA,k,6)

colnames(table5)=c("Alpha","Beta","Gamma",
                   "MseAlpha","MseBeta","MseGamma",
                   "AI","AR","MR")
colnames(table6)=c("AlphaSD","AlphaSE","AlphaCP",
                   "BetaSD","BetaSE","BetaCP",
                   "GammaSD","GammaSE","GammaCP")
colnames(table7)=c("MeanXSD","MeanXSE","MeanXCP",
                   "MeanYSD","MeanYSE","MeanYCP")
filename="Tables_5_6_7.RData"

# repl=10
# repl=100
# repl=1000
repl=10000

pt1=Sys.time()
for(i in 1:k){
  cat("Row =",i,"of",k,"with",repl,"Replicates:","\n")
  n=N[i]
  Alpha=alpha[i]
  Beta=beta[i]
  Gamma=gamma[i]
  w=w.vec[i]
  
  Real=c(Alpha,Beta,Gamma,mBurrIII(Alpha,Gamma),mBurrIII(Beta,Gamma))
  
  # id=0
  # phat=replicate(repl,mle.sim(n, Alpha, Beta, Gamma,w,id=id))
  # mean.mat=apply(phat, c(1,2), mean)
  # d=sweep(phat[1,,],2,Real)^2
  # mse.vec=rowMeans(d)
  # sd.vec=apply(phat[1,,], 1, sd)
  # mr=max(phat[5,1,])
  
  phat=plyr::raply(repl,mle.sim(n, Alpha, Beta, Gamma,w),.progress = "text")
  mean.mat=apply(phat, c(2,3), mean)
  d=sweep(phat[,1,],1,Real)^2
  mse.vec=colMeans(d)
  sd.vec=apply(phat[,1,], 2, sd)
  mr=max(phat[,5,1])
  
  table5[i,1:3]=mean.mat[1,1:3]
  # table5[i,4:6]=mse.vec[1:3]
  table5[i,7:8]=mean.mat[4:5,1]
  table5[i,9]=mr
  
  table6[i,c(1,4,7)]=sd.vec[1:3]
  table6[i,c(2,5,8)]=mean.mat[2,1:3]
  table6[i,c(3,6,9)]=mean.mat[3,1:3]
  
  table5[i,4:6]=table6[i,c(1,4,7)]^2+(table5[i,1:3]-Real[1:3])^2
  
  table7[i,c(1,4)]=sd.vec[4:5]
  table7[i,c(2,5)]=mean.mat[2,4:5]
  table7[i,c(3,6)]=mean.mat[3,4:5]

  save(repl,param0,table5,table6,table7,file = filename)
  cat("\n")
}
pt2=Sys.time()
pt=pt2-pt1
pt

table5out=cbind(param0,table5)
table6out=cbind(param0,table6)
table7out=cbind(param0,table7)

filename="Tables_5_6_7.RData"
save(repl,param0,table5,table6,table7,
     table5out,table6out,table7out,file = filename)
load(filename)

repl

round(table5out,3)
round(table6out,3)
round(table7out,3)

# Table 8 Parameters -----------------------------------------------

# table8=matrix(NA,6,6)
colnames(table8)=c("overall.stat","overall.boot.stat","overall.reject",
               "copula.stat","copula.boot.stat","copula.reject")
rownames(table8)=c("GFGM.BurrIII","GFGM.exp","Clayton.BurrIII",
                   "Clayton.exp","Indep.BurrIII","Indep.exp")

p=3;q=2;theta=0.7
Alpha=1.5;Beta=1;Gamma=1
w=6

Lambda1=0.5; Lambda2=1

n=200
# B=500; repl=500
B=100; repl=50

# Table 8, Row 1 GFGM.BurrIII --------------------------------

# sim8.1=plyr::raply(repl,boot.gof.sim.BurrIII(n, Alpha, Beta, Gamma,w,B=B,.progress = "win"),.progress = "text")
sim8.1
table8[1,]=colMeans(sim8.1)
save(sim8.1,file="sim8.1.RData")

# Table 8, Row 2 GFGM.exp --------------------------------

# sim8.2=plyr::raply(repl,boot.gof.sim.GFGM.exp(n,Lambda1,Lambda2,w,B=B,.progress = "win"),.progress = "text")
sim8.2
table8[2,]=colMeans(sim8.2)
save(sim8.2,file="sim8.2.RData")

# Table 8, Row 3 Clayton.BurrIII --------------------------------

# sim8.3=plyr::raply(repl,boot.gof.Clayton.BurrIII(n,Alpha, Beta, Gamma,w,B=B,.progress = "win"),.progress = "text")
sim8.3
table8[3,]=colMeans(sim8.3)
save(sim8.3,file="sim8.3.RData")

# Table 8, Row 4 Clayton.exp --------------------------------

# sim8.4=plyr::raply(repl,boot.gof.Clayton.exp(n,Lambda1,Lambda2,w,B=B,.progress = "win"),.progress = "text")
sim8.4
table8[4,]=colMeans(sim8.4)
save(sim8.4,file="sim8.4.RData")

# Table 8, Row 5 Indep.BurrIII --------------------------------

# sim8.5=plyr::raply(repl,boot.gof.Indep.BurrIII(n,Alpha, Beta, Gamma,w,B=B,.progress = "win"),.progress = "text")
sim8.5
table8[5,]=colMeans(sim8.5)
save(sim8.5,file="sim8.5.RData")

# Table 8, Row 6 Indep.exp --------------------------------

# sim8.6=plyr::raply(repl,boot.gof.Indep.exp(n,Lambda1,Lambda2,w,B=B,.progress = "win"),.progress = "text")
sim8.6
table8[6,]=colMeans(sim8.6)
save(sim8.6,file="sim8.6.RData")

# Final Results -------------------------------------------------

save(table8,file="table8.RData")
load("table8.RData")
round(table8,3)
