

# Fig. 1 --------------------------------------------------------

lambda=2

k=50
t1=t2=seq(0,3,length.out = k)


par(mfrow=c(2,2))

theta0=1; theta1=1; theta2=1
f=outer(t1,t2,dT1T2,theta0=theta0,theta1=theta1,theta2=theta2,lambda=lambda)
persp3D(t1,t2,f, col = "blue", bty = "b2",shade = 0.5,zlim=c(0,3),
        xlab="t1",ylab="t2",zlab="f",
        ticktype = "detailed", facets = FALSE,theta=-35,phi=10)

theta0=0.5; theta1=0.8; theta2=0.8
f=outer(t1,t2,dT1T2,theta0=theta0,theta1=theta1,theta2=theta2,lambda=lambda)
persp3D(t1,t2,f, col = "blue", bty = "b2",shade = 0.5,zlim=c(0,2),
        xlab="t1",ylab="t2",zlab="f",
        ticktype = "detailed", facets = FALSE,theta=-35,phi=10)

theta0=0; theta1=0.4; theta2=0.4
f=outer(t1,t2,dT1T2,theta0=theta0,theta1=theta1,theta2=theta2,lambda=lambda)
persp3D(t1,t2,f, col = "blue", bty = "b2",shade = 0.5,zlim=c(0,1),
        xlab="t1",ylab="t2",zlab="f",
        ticktype = "detailed", facets = FALSE,theta=-35,phi=10)

theta0=0.2; theta1=0.2; theta2=0.2
f=outer(t1,t2,dT1T2,theta0=theta0,theta1=theta1,theta2=theta2,lambda=lambda)
persp3D(t1,t2,f, col = "blue", bty = "b2",shade = 0.5,zlim=c(0,1),
        xlab="t1",ylab="t2",zlab="f",
        ticktype = "detailed", facets = FALSE,theta=-35,phi=10)

par(mfrow=c(1,1))

# Data analysis -------------------------------------------------

x=scan()
0.0035 0.0181 0.0435 0.0813 0.0860 0.1286 0.1483 0.1484 0.1929 0.4449

alpha=scan()
2 2 0 0 2 1 0 1 1 2

theta0=0.8
theta1=1.2
theta2=1
lambda=0.6
n=30
m=10
tau=1
r=rep(2,m)
rr=length(x)
tstar=x[m]

minuslogl(theta0=theta0,theta1=theta1,theta2=theta2,lambda=lambda)

start=list(theta0=theta0,theta1=theta1,theta2=theta2,lambda=lambda)
pars=c(theta0=theta0,theta1=theta1,theta2=theta2,lambda=lambda)
mle(minuslogl,start=start)
method = c("Nelder-Mead", "BFGS", "CG", "L-BFGS-B", "SANN",
           "Brent")
i=0
i=i+1; method[i]
mle(minuslogl,start=start,method=method[i])
i=0
i=i+1; method[i]
optim(minuslogl2,par=pars,method=method[i])

i=0
i=i+1; method[i]
fit=constrOptim(theta=pars,minuslogl2,grad=NULL,
                ui=diag(4),ci=rep(0,4))
fit
minuslogl2(fit$par)

mle(minuslogl,start=start,method="L-BFGS-B",lower=rep(0,4))
mle2(minuslogl,start=start)
mle2(minuslogl,start=start,method="L-BFGS-B",lower=rep(0,4))


glambda(lambda)
mle(glambda,start=list(lambda=lambda))

k=50
Lambda=seq(0.1,10,length.out = k)
g=c()
for (i in 1:k) {
  g[i]=glambda(Lambda[i])
}
plot(Lambda,g,type="l")

k=10000
Lambda=lambda
for (i in 2:k) {
  Lambda[i]=hlambda(Lambda[i-1])
}
plot(Lambda,type="l")

abstol=0.000002
maxit=10000
Lambda=lambda
i=1
repeat {
  cat(i, "")
  i=i+1
  Lambda[i]=hlambda(Lambda[i-1])
  d=abs(Lambda[i]-Lambda[i-1])
  if(d<abstol | i==maxit) {
    cat(i, "\n")
    break
  }
}
plot(Lambda,type="l")
lambdahat=Lambda[i]
lambdahat
thetahat=thetaLambda(lambdahat)
thetahat
phat=c(thetahat,lambda=lambdahat)
phat
pars
table(alpha)
I0=Ifunc(pars)
Ihat=Ifunc(phat)
I0
solve(I0)
Ihat
solve(Ihat)

V0=Vfunc(I0)
Vhat=Vfunc(Ihat)
V0
Vhat

ACIfunc(pars,V0)
ACIfunc(phat,Vhat)

p0=c(theta0=0.8934,theta1=0.6627,theta2=0.8136,lambda=0.6935)
i0=Ifunc(p0)
i0
v0=Vfunc(i0)
v0
ACIfunc(p0,v0)




# Data analysis -------------------------------------------------

x=scan()
0.0035 0.0181 0.0435 0.0813 0.0860 0.1286 0.1483 0.1484 0.1929 0.4449

alpha=scan()
2 2 0 0 2 1 0 1 1 2

table4=rbind(t_i=x,alpha_i=alpha)
colnames(table4)=1:10
table4

theta0=0.8
theta1=1.2
theta2=1
lambda=0.6
pars=c(theta0=theta0,theta1=theta1,theta2=theta2,lambda=lambda)

n=30
m=10
tau=1
r=rep(2,m)
rr=length(x)
tstar=x[m]

k=10000
Lambda=lambda
for (i in 2:k) {
  Lambda[i]=hlambda(Lambda[i-1])
}
# Fig 3
plot(Lambda,type="l",xlab="n",ylab=expression(lambda),
     ylim=c(0.6,0.7))

phat=estimate(lambda0 = lambda,abstol = 2e-6)
Ihat=Ifunc(phat)
Vhat=Vfunc(Ihat)
ACIhat=ACIfunc(phat,Vhat)
BootPCIhat=BootPCIfunc(phat,n,m,r,tau)
table5=cbind(TrueValue=pars,MLE=phat,ACIhat,BootPCIhat)
table5

# Simulation example ------------------------------------------

theta1=1.2
theta2=1
lambda=0.6

tau=1

n=20
m=4
r=rep(4,m)

theta0=0.3

pars=c(theta0=theta0,theta1=theta1,theta2=theta2,lambda=lambda)

res=rPHCS(n,theta0,theta1,theta2,lambda,m,r,tau)
res

x=res$x
alpha=res$alpha
tstar=res$tstar

k=10000
Lambda=lambda
for (i in 2:k) {
  Lambda[i]=hlambda(Lambda[i-1])
}
plot(Lambda,type="l")

abstol=1e-4
maxit=1e4
Lambda=lambda
i=1
repeat {
  cat(i, "")
  i=i+1
  Lambda[i]=hlambda(Lambda[i-1])
  d=abs(Lambda[i]-Lambda[i-1])
  if(d<abstol | i==maxit) {
    cat(i, "\n")
    break
  }
}
plot(Lambda,type="l")
lambdahat=Lambda[i]
lambdahat
thetahat=thetaLambda(lambdahat)
thetahat
phat=c(thetahat,lambda=lambdahat)
phat
phat=estimate(lambda0 = lambda)
phat
pars
table(alpha)
I0=Ifunc(pars)
Ihat=Ifunc(phat)
I0
solve(I0)
Ihat
solve(Ihat)

V0=Vfunc(I0)
Vhat=Vfunc(Ihat)
V0
Vhat

ACI0=ACIfunc(pars,V0)
ACIhat=ACIfunc(phat,Vhat)
ACIhat
pars
cover.test(ACIhat,pars)


BootPCIhat=BootPCIfunc(phat,n,m,r,tau,N=200)
BootPCIhat
pars
cover.test(BootPCIhat,pars)

simPHCS(pars,n,m,r)

repl=10
repsim=raply(repl,simPHCS(pars,n,m,r),.progress = "text")
repsim
pmat=repsim[,,"phat"]
pmat
ACImat=repsim[,,"ACI"]
ACImat
BootPmat=repsim[,,"BootP"]
BootPmat
d=sweep(pmat,2,pars,"-")
d
rb=sweep(d,2,pars,"/")
rb
rab=colMeans(abs(rb),na.rm = T)
rab
mse=colMeans(d^2,na.rm = T)
mse
ACI=colMeans(ACImat,na.rm = T)
ACI
BootP=colMeans(BootPmat,na.rm = T)
BootP


# Simulation run ------------------------------------------------

# all ####
Theta0=rep(c(0.001,0.3,0.8,1.2,1.6),times=2)
theta1=1.2
theta2=1
lambda=0.6
tau=1
N=200
gama=0.05

repl=10000
# repl=1000
# repl=100
# repl=10

# table1 ####
tablename="Table1"
outname=paste0(tablename,".RData")
n=20
mvec=rep(c(4,8),each=5)
r1=rep(4,4)
r2=c(rep(3,2),rep(1,6))

# table2 ####
tablename="Table2"
outname=paste0(tablename,".RData")
n=30
mvec=rep(c(6,10),each=5)
r1=rep(4,6)
r2=rep(2,10)

# table3 ####
tablename="Table3"
outname=paste0(tablename,".RData")
n=50
mvec=rep(c(10,15),each=5)
r1=rep(4,10)
r2=c(5,4,rep(2,13))

#####
table.MSEs=table.RABias=table.ACI=table.BootP=
  matrix(NA,10,6)
colnames(table.MSEs)=colnames(table.RABias)=colnames(table.ACI)=
  colnames(table.BootP)=c("m","t0","theta0","theta1","theta2","lambda")
table.MSEs[,1:2]=table.RABias[,1:2][,1:2]=table.ACI[,1:2]=
  table.BootP[,1:2]=cbind(mvec,Theta0)


pt0=proc.time()
for(i in 1:10){
  theta0=Theta0[i]
  pars=c(theta0=theta0,theta1=theta1,theta2=theta2,lambda=lambda)
  m=mvec[i]
  r=if(i<=5) r1 else r2
  repsim=raply(repl,simPHCS(pars,n,m,r,tau=1,N=200,gama=0.05),.progress = "text")
  pmat=repsim[,,"phat"]
  ACImat=repsim[,,"ACI"]
  BootPmat=repsim[,,"BootP"]
  d=sweep(pmat,2,pars,"-")
  rb=sweep(d,2,pars,"/")
  rab=colMeans(abs(rb),na.rm = T)
  mse=colMeans(d^2,na.rm = T)
  ACI=colMeans(ACImat,na.rm = T)
  BootP=colMeans(BootPmat,na.rm = T)
  
  table.MSEs[i,-(1:2)]=mse
  table.RABias[i,-(1:2)]=rab
  table.ACI[i,-(1:2)]=ACI
  table.BootP[i,-(1:2)]=BootP
}
pt1=proc.time()-pt0; pt1
pt1/60
pt1/3600

i0=i
pt0=proc.time()
for(i in i0:10){
  theta0=Theta0[i]
  pars=c(theta0=theta0,theta1=theta1,theta2=theta2,lambda=lambda)
  m=mvec[i]
  r=if(i<=5) r1 else r2
  repsim=raply(repl,simPHCS(pars,n,m,r,tau=1,N=200,gama=0.05),.progress = "text")
  pmat=repsim[,,"phat"]
  ACImat=repsim[,,"ACI"]
  BootPmat=repsim[,,"BootP"]
  d=sweep(pmat,2,pars,"-")
  rb=sweep(d,2,pars,"/")
  rab=colMeans(abs(rb),na.rm = T)
  mse=colMeans(d^2,na.rm = T)
  ACI=colMeans(ACImat,na.rm = T)
  BootP=colMeans(BootPmat,na.rm = T)
  
  table.MSEs[i,-(1:2)]=mse
  table.RABias[i,-(1:2)]=rab
  table.ACI[i,-(1:2)]=ACI
  table.BootP[i,-(1:2)]=BootP
}
pt1=proc.time()-pt0; pt1
pt1/60
pt1/3600

cat(tablename)
repl
table.MSEs
table.RABias
table.ACI
table.BootP

# save(tablename,repl,n,table.MSEs,table.RABias,table.ACI,table.BootP,file = outname)
# load(outname)

cat(tablename)
repl
round(table.MSEs,3)
round(table.RABias,3)
round(table.ACI,3)
round(table.BootP,3)

